import { unref as g, computed as r, toValue as I } from "vue";
import { getUserInitials as A } from "../../utils.js";
function m(t) {
  return typeof t == "function" ? t() : g(t);
}
typeof WorkerGlobalScope < "u" && globalThis instanceof WorkerGlobalScope;
class d extends Error {
}
d.prototype.name = "InvalidTokenError";
function w(t) {
  return decodeURIComponent(atob(t).replace(/(.)/g, (n, o) => {
    let s = o.charCodeAt(0).toString(16).toUpperCase();
    return s.length < 2 && (s = "0" + s), "%" + s;
  }));
}
function y(t) {
  let n = t.replace(/-/g, "+").replace(/_/g, "/");
  switch (n.length % 4) {
    case 0:
      break;
    case 2:
      n += "==";
      break;
    case 3:
      n += "=";
      break;
    default:
      throw new Error("base64 string is not of the correct length");
  }
  try {
    return w(n);
  } catch {
    return atob(n);
  }
}
function $(t, n) {
  if (typeof t != "string")
    throw new d("Invalid token specified: must be a string");
  n || (n = {});
  const o = n.header === !0 ? 0 : 1, s = t.split(".")[o];
  if (typeof s != "string")
    throw new d(`Invalid token specified: missing part #${o + 1}`);
  let a;
  try {
    a = y(s);
  } catch (c) {
    throw new d(`Invalid token specified: invalid base64 for part #${o + 1} (${c.message})`);
  }
  try {
    return JSON.parse(a);
  } catch (c) {
    throw new d(`Invalid token specified: invalid json for part #${o + 1} (${c.message})`);
  }
}
function T(t, n = {}) {
  const {
    onError: o,
    fallbackValue: s = null
  } = n, a = (f, p) => {
    try {
      return $(f, p);
    } catch (l) {
      return o == null || o(l), s;
    }
  }, c = r(() => a(m(t), { header: !0 })), i = r(() => a(m(t)));
  return {
    header: c,
    payload: i
  };
}
function N(t) {
  if (import.meta.server)
    return {
      accessToken: useState("accessToken", () => ""),
      profilePicture: useState("profilePicture", () => null),
      initials: r(() => ""),
      account: r({ get: () => null, set: () => {
      } }),
      fullName: r(() => ""),
      userId: r(() => ""),
      roles: r(() => []),
      isImpersonator: r(() => !1),
      isAdmin: r(() => !1),
      signOut: () => {
      }
    };
  const { $msalInstance: n, $accessTokenRef: o, $profilePictureRef: s } = useNuxtApp(), a = r(() => g(I(t == null ? void 0 : t.impersonateAs)) ?? void 0), c = r(() => {
    var e;
    return (e = a.value) == null ? void 0 : e.id;
  }), i = r({
    get: () => n.getActiveAccount(),
    set: (e) => n.setActiveAccount(e)
  }), f = r(() => {
    var e, u;
    return ((e = a.value) == null ? void 0 : e.name) ?? ((u = i.value) == null ? void 0 : u.name);
  }), p = r(() => A(f.value)), l = r(() => {
    var e, u;
    return (u = (e = i.value) == null ? void 0 : e.idTokenClaims) == null ? void 0 : u.roles;
  }), v = r(() => {
    var e;
    return (e = l.value) == null ? void 0 : e.includes("ImpersonatorAccess");
  }), h = r(() => {
    var e;
    return (e = l.value) == null ? void 0 : e.includes("AdminAccess");
  }), { payload: k } = T(o), b = r(() => {
    var e;
    return c.value ?? ((e = k.value) == null ? void 0 : e.onpremisessamaccountname);
  });
  return {
    accessToken: o,
    profilePicture: s,
    initials: p,
    account: i,
    fullName: f,
    userId: b,
    roles: l,
    isImpersonator: v,
    isAdmin: h,
    signOut: () => {
      n.logoutRedirect({ account: i.value });
    }
  };
}
export {
  N as default,
  N as useAuth
};
