import { defineNuxtPlugin as k, useRuntimeConfig as T } from "#app";
import { ref as m } from "vue";
const v = k({
  name: "msal",
  setup: async () => {
    var u;
    if (import.meta.server)
      return {};
    const o = T(), { createStandardPublicClientApplication: d, InteractionRequiredAuthError: s } = await import("@azure/msal-browser"), c = [o.public.appApiScope], i = { scopes: c, state: window.location.pathname }, e = await d({
      auth: {
        clientId: o.public.appId,
        authority: `https://login.microsoftonline.com/${o.public.appTenantId}`,
        postLogoutRedirectUri: `https://${window.location.host}/sign-out`,
        redirectUri: `https://${window.location.host}/`,
        navigateToLoginRequestUrl: !0
      },
      system: {
        iframeHashTimeout: 1e4,
        tokenRenewalOffsetSeconds: 300
      },
      cache: {
        cacheLocation: "localStorage",
        storeAuthStateInCookie: !1
      },
      ...o.public.msalConfig
    }), r = async () => await e.acquireTokenSilent({ scopes: c }).then(({ accessToken: t }) => t).catch(async (t) => (t instanceof s && await e.acquireTokenRedirect(i), "")), l = e.getAllAccounts();
    try {
      const { accessToken: n, account: t } = await e.ssoSilent({
        scopes: c,
        account: l[0]
      });
      e.setActiveAccount(t);
      const a = m();
      (async () => {
        const { accessToken: w } = await e.acquireTokenSilent({
          scopes: ["User.Read"],
          account: l[0]
        }), h = await fetch("https://graph.microsoft.com/v1.0/me/photo/$value", {
          headers: {
            Authorization: `Bearer ${w}`
          }
        });
        if (h.ok) {
          const g = await h.blob();
          a.value = URL.createObjectURL(g);
        } else
          a.value = null;
      })().catch(() => {
        a.value = null;
      });
      const p = m(n), f = (u = t == null ? void 0 : t.idTokenClaims) == null ? void 0 : u.exp;
      return setInterval(async () => {
        p.value = await r();
      }, f ? f * 1e3 - Date.now() : 3e5), { provide: { msalInstance: e, accessTokenRef: p, profilePictureRef: a, refreshToken: r } };
    } catch (n) {
      return n instanceof s && await e.loginRedirect(i), {};
    }
  }
});
export {
  v as default
};
